/* =================================================================
 *  Abstract data type for DAG.
 */
typedef struct {
    int  nInstructions;	   /* # of instructions; their names are 0,...,n-1 */
    char *blockID;	   /* unique identifier of the basic block	   */
    int  *instructionType; /* operation type of each instruction	   */
    ELEM **successors;	   /* adjacency lists of successors of nodes	   */
} DAG_type;

/*
 *  Maximum length of a line in the file that stores the DAG.
 */
#define MAX_LINE_LENGTH  2048

/* =================================================================
 *  Routines available for an instance of a DAG.
 */
DAG_type *getDAG( char *problem );
void	 printDAG( DAG_type *DAG );
