
#include "global.h"
#include "list.h"


/*
 *  Insert an item into the front of a list.
 */
void
insertList( ELEM **list, int vertex, int latency )
{
    ELEM  *edge;

    edge = (ELEM *)calloc( (size_t)1, sizeof(ELEM) );
    edge->vertex  = vertex;
    edge->latency = latency;

    edge->next = *list;
    *list = edge;
}

/*
 *  Destroy a list.
 */
void
destroyList( ELEM *list )
{
    ELEM  *edge;

    while( list != NULL ) {
	edge = list->next;
	free( list );
	list = edge;
    }
}

/*
 *  Determine the length of a list.
 */
int
length( ELEM *list )
{
    int  len;
    ELEM *p;

    len = 0;
    for( p = list; p != NULL; p = p->next ) {
	len++;
    }

    return( len );
}

