/* =================================================================
 *  Abstract data type for list scheduler.
 */

typedef struct {
    int  n;		/* number of instructions; their names are 1,...,n */
    int  *varType;	/* operation type of each instruction i		   */
    int  *EST;		/* current earlist start time of i		   */
    int  *maxDelay;	/* critical path length from i to leaf node	   */
    int  *nPreds;	/* # of predecessors of a node not yet scheduled   */
    int  *nSuccs;	/* # of successors of a node			   */
    BOOL *isScheduled;	/* has this instruction been scheduled?		   */
    ELEM **latencySucc;
    ELEM **latencyPred;
} LS_type;

/* =================================================================
 *  Routine for scheduling a DAG using list scheduling.
 */
int    listScheduler( DAG_type *DAG, int order[] );
