/* =================================================================
 *  Defining the processor
 */

/*
 *  Maximum latency of any instruction.
 */
#define   MAX_LATENCY	50

/*
 *  Number of different instruction types.
 *  Assumption: there is at least one functional unit for each type of
 *  instruction, each instruction can only execute on its corresponding
 *  functional unit, only one functional unit is involved in the
 *  execution of an instruction.
 */
#define   N_INSTRUCTION_TYPES	5

#define   INTEGER_INSTR  0
#define   FLOAT_INSTR    1
#define   LDST_INSTR     2
#define   BRANCH_INSTR   3
#define   PSEUDO_INSTR   4

/* =================================================================
 *  Routines for answering queries about the processor model
 */
int  getInstructionType( char *line );
int  nFunctionalUnits( int type );
void setFunctionalUnits( char *units );

