/* =================================================================
 *  Stack abstract data type for storing variables (integers)
 *  in the range 1, ..., n.
 *
 *  All operations are as expected, except the push operation.
 *  Push pushes a variable on the stack and marks it as being on 
 *  the stack, unless the variable was already on the stack, in
 *  which case it is not added again.
 */

typedef struct {
    int  *stack;
    BOOL *on_stack;
    int	 top;
} STACK_t;

/*
 *  Stack routines available.
 */
STACK_t  *createStack( int n );
void     destroyStack( STACK_t *s );
BOOL     stackEmpty( STACK_t *s );
void     push( int v, STACK_t *s );
int      pop( STACK_t *s );

